#!/usr/bin/python

from subprocess import PIPE, Popen
import os
import subprocess
import SimpleITK as sitk
import numpy as np
from util import *
import os

base_dir = "/home/ubuntu/data/trap_refreg" # output directory
data_dir = "/home/ubuntu/data/trap_downsamp_nii/" # directory of brains to be registered
refbrain = "/home/ubuntu/data/refbrain.nii" # reference brain to be registered to 

fnames = os.listdir(data_dir)

def elastix_register(ref, floating, output_dir):
    cmd = "elastix -f %s -m %s -out %s -p params/rigid.txt -p params/affine.txt -p params/bspline.txt > /tmp/out.txt 2>&1" % (ref, floating, output_dir)
    print cmd
    os.system(cmd)   

def main():
    for f in fnames:
        ch1_name = os.path.join(data_dir, f+"_ch1.nii")
        ch1_output = os.path.join(base_dir, f+"_ch1")        
        ch2_name = os.path.join(data_dir, f+"_ch2.nii")
        ch2_output = os.path.join(base_dir, f+"_ch2")
        if not os.path.exists(ch1_output):
            os.makedirs(ch1_output)
        if not os.path.exists(ch2_output):
            os.makedirs(ch2_output)
        elastix_register(refbrain, ch1_name, ch1_output)
        #elastix_register(refbrain, ch2_name, ch2_output)

if __name__ == "__main__":
    main()


