import SimpleITK as sitk
import numpy as np
import os
pixel_size = 4*(5.16/1000.) # in mm
def average_volumes_old(fnames, out_path, spacing=[pixel_size, pixel_size, pixel_size]):
    s = "cmtk average_images -v -o %s" % out_path
    for f in fnames:
        s += " " + f
    print s
    os.system(s)

def average_volumes(fnames, out_path, spacing=[0.025, 0.025, 0.025]):
    reader = sitk.ImageFileReader()
    images = []
    for f in fnames:
        print f
        reader.SetFileName(f)
        volume = reader.Execute()
        volume_flat = sitk.GetArrayFromImage(volume)
        dims = volume_flat.shape
        volume_flat = volume_flat.flatten()
        images.append(volume_flat.astype(np.float))
    reference_flat = np.mean(images,axis=0)
    reference_flat = reference_flat.astype(np.uint16)
    avg_vol = sitk.GetImageFromArray(reference_flat.reshape(dims))
    avg_vol.SetSpacing(spacing)
    sitk.WriteImage(avg_vol, out_path)

